﻿
Funbit.Ets.Telemetry.Dashboard.prototype.initialize = function (skinConfig, utils) {

    utils.preloadImages([
        'images/bg.jpg'
    ]);

}

Funbit.Ets.Telemetry.Dashboard.prototype.filter = function (data, utils) {

	data.rollTruck = data.truck.placement.roll;
	data.rollTrailer = data.trailer.placement.roll;
	data.steering = data.truck.gameSteer;

    return data;
};

	
function resetMax() {
	if (HasMax) {
		HasMax = false;
		XMin = 999;
		XMax = -999;
		YMin = 999;
		YMax = -999;
		SpdMax = -999;
		$('.minY').text("0");
		$('.maxY').text("0");
		$('.minX').text("0");
		$('.maxX').text("0");
	};
};
resetMax();

// calculate Gs from constant radius circle & current speed
var radius = 40; // default radius
$('.radius').text(radius+"m");
function setRadius() {
	var oldrad = radius;
	var rad = prompt('To calculate lateral g-forces from the current speed, on a constant radius circle, enter the radius (in meters).\n\nTo use the telemetry values, enter 0.\n\n',radius);
	radius = Math.max(parseInt(rad) || 0,0);
	if (radius==0) {
		$('.radius').text("accel");
	} else {
		$('.radius').text(radius+"m");
	};
	if (radius!=oldrad) {
		resetMax();
	};
};
function speedToGs(spdkm,steer) {
	var calcGs = 0;
	if (Math.abs(steer)>.05) {
		var spdms = spdkm / 3.6;
		var calcGs = (spdms*spdms)/radius/9.8;
	};
	return calcGs;
};
	
var isRacing,raceStart,isBraking,brakeStartTime,brakeStartX,brakeStartZ,brakeEndX,brakeEndZ,brakeStartSpeed;
isRacing = false;
isBraking = false;
brakeStart = 0;
stopDist = 0;

var resetting = resetOnStart = false;

var HasMax,XMin, XMax, YMin, YMax, SpdMax;
HasMax = true;
XMin = XMax = YMin = YMax = SpdMax = 0;

var roll = 1;

var startTime = new Date().getTime();
$('.brakeInfo').text("Toggle maxima via beacon.");
$('.brakeTime').text("Reset maxima by activating wipers.");


Funbit.Ets.Telemetry.Dashboard.prototype.render = function (data, utils) {
	
	$('.minX').text('');
	$('.maxX').text('');
	$('.minY').text('');
	$('.maxY').text('');

	$('.radius').css({visibility:"hidden"});
	$('.reset').css({visibility:"hidden"});
	
	$('.speedK').text('');
	$('.speedM').text('');

	// g-force meter background dimensions
	var spotSize=40;
	var centerX=208-(spotSize/2);
	var centerY=205-(spotSize/2);
	var radFact=110;

	var posX = centerX+"px";
	var posY = centerY+"px";

	var speed = data.truck.speed;
	var throttle = data.truck.userThrottle;
	var steer = data.truck.gameSteer;
	
	var showCurr = (!data.truck.lightsBeaconOn && speed>.5);
	var rollAngle = Math.abs(data.truck.placement.roll*360); // (-0.5,0.5) corresponds to (-180,180).
	//$('.debug').text(rollAngle.toFixed(1));
	
	SpdMax = Math.max(SpdMax,speed);
		
	// ** Display G-Values ***
	var forceX = -data.truck.acceleration.x/10;
	var forceY = -data.truck.acceleration.z/10;
	var xCol = "white";
	if (radius!=0) {
		forceX = speedToGs(speed,steer)
		forceX = forceX * Math.sign(steer);
		xCol = "yellow";
	};
	$('.minX').css({color:xCol});
	$('.maxX').css({color:xCol});
	//console.log(XMin+", "+XMax+", "+YMin+", "+YMax)

	// display only the g-value that's the highest of all 4 directions
	// and save the maxima
	if (Math.abs(forceY)>Math.abs(forceX)) {
		if (forceY<-0.1) {
			if (showCurr) {$('.minY').text(Math.abs(forceY).toFixed(1))};
			YMin = Math.min(YMin,forceY);
			HasMax = true;
		} else if (forceY>0.1) {
			if (showCurr) {$('.maxY').text(Math.abs(forceY).toFixed(1))};
			YMax = Math.max(YMax,forceY);
			HasMax = true;
		};
	} else {
		if (forceX<-0.1) {
			if (showCurr) {$('.minX').text(Math.abs(forceX).toFixed(1))};
			XMin = Math.min(XMin,forceX);
			HasMax = true;
		} else if (forceX>0.1){
			if (showCurr) {$('.maxX').text(Math.abs(forceX).toFixed(1))};
			XMax = Math.max(XMax,forceX);
			HasMax = true;
		};
	};
	
	// ** Display G-Spot ***
	// convert x/y "position" on a square into one on a circle (xyS=square pos, xyC=circle pos)
	// http://squircular.blogspot.ca/2015/09/mapping-circle-to-square.html
	// xC = xS √( 1 - ½ yS² )
	// yC = yS √( 1 - ½ xS² )
	var xC = forceX * Math.sqrt(1-(forceY*forceY)*0.5);
	var yC = forceY * Math.sqrt(1-(forceX*forceX)*0.5);
	xC = Math.max(Math.min(xC,.8),-.8);
	yC = Math.max(Math.min(yC,.8),-.8);
	
	var posX = centerX+xC*radFact+"px";
	var posY = centerY+yC*radFact+"px";

	$('.gSpot').css({
		position: "absolute",
		left: posX,
		top: posY
	});

	// *** Roll-Indicator ***
	// hide trailer indicator if none connected
	if (data.trailer.attached) {
		$('.rollTrailer').css({display:"block"});
	} else {
		$('.rollTrailer').css({display:"none"});
	};

	// *** 0-100 Data ***
	if (throttle==1) {
		if ((speed<2) && (speed>.1)) {
			isRacing = true;
			raceStart = new Date().getTime();
			$('.brakeTime').text("measuring 0-100km/h performance");
		} else {		
			if (isRacing && (speed>99.9)) {
				$('.brakeTime').text("0 to 100 km/h in " + ((new Date().getTime() - raceStart)/1000).toFixed(1) + "sec");
				isRacing = false;
			};
		};
	} else {
		if (isRacing) {$('.brakeTime').text("")};
		isRacing = false;
	};
	//$('.debug').text(throttle.toFixed(2) + ", " + isRacing);
	
	
	if (showCurr) {
		$('.mode').text('G-Force');

		if (speed>0.5) {
			$('.speedK').text("km/h   " + parseInt(speed));
			$('.speedM').text("mph   " + parseInt(speed * 0.621371));
			if (resetOnStart) {
				resetOnStart = false;
				resetMax();
			};
		};
		
	} else {
		$('.mode').text('Maxima');
		if (HasMax) {
			$('.radius').css({visibility:"visible"});
			$('.reset').css({visibility:"visible"});

			if (Math.abs(YMin)!=999) {$('.minY').text(Math.abs(YMin).toFixed(2))};
			if (Math.abs(YMax)!=999) {$('.maxY').text(Math.abs(YMax).toFixed(2))};
			if (Math.abs(XMin)!=999) {$('.minX').text(Math.abs(XMin).toFixed(2))};
			if (Math.abs(XMax)!=999) {$('.maxX').text(Math.abs(XMax).toFixed(2))};
			$('.speedK').text("km/h   " + parseInt(SpdMax));
			$('.speedM').text("mph   " + parseInt(SpdMax * 0.621371));
		};
		if (data.truck.wipersOn) {
			if (!resetting) {
				resetMax();
				resetting = true;
			};
		} else {
			resetting = false;
		};
	};
	
	// *** Brake/Stopping Measurement ***
	$('.brakeInfo').css({color:"#FFEFD5"});
	var brakePower = data.truck.userBrake; // gameBrake seems to be the same
	
	if (!isBraking) {
		if (speed>1) {
			//$('.brakeTime').text("");
		};
		if (brakePower!=0) {
			isBraking = true;
			brakeStartTime = new Date().getTime();
			brakeStartX = data.truck.placement.x;
			brakeStartZ = data.truck.placement.z;
			brakeDist = brakeStartX;
			brakeStartSpeed = speed;
		};
	} else {
		if (brakePower==0) {
			if ((isBraking) && (speed>.1)) {$('.brakeTime').text("")};
			isBraking = false;
		} else {
			if (speed>0.1) {
				stopDist = Math.sqrt(Math.pow(data.truck.placement.x - brakeStartX, 2) + Math.pow(data.truck.placement.z - brakeStartZ, 2));
				if (speed>1) {
					$('.brakeTime').text("Braking from "+parseInt(brakeStartSpeed) + "km/h, for "+((new Date().getTime() - brakeStartTime)/1000).toFixed(1) + "sec, " + parseInt(stopDist) + "m");
				} else {
					$('.brakeTime').text("Stopped from "+parseInt(brakeStartSpeed) + "km/h in "+((new Date().getTime() - brakeStartTime)/1000).toFixed(1) + "sec, " + parseInt(stopDist) + "m");
				};
			};
		};
	};
	
	// *** Brake Temp ***
	var brakeTemp = data.truck.brakeTemperature;
	if (brakePower==0) {
		if (data.truck.parkBrakeOn) {
			$('.brakeStrength').css({display:"block"});
			$('.brakeStrength').css({backgroundColor:"white"});
			$('.brakeStrength').css({top:"380px"});
			$('.brakeStrength').css({height:"68px"});
			resetOnStart = true;
		} else {
			$('.brakeStrength').css({display:"none"});
		};
	} else {
		$('.brakeStrength').css({backgroundColor:"yellow"});
		$('.brakeStrength').css({display:"block"});
		$('.brakeStrength').css({top:(381+68)-brakePower*68+"px"});
		$('.brakeStrength').css({height:brakePower*68+"px"});
	};
	
	$('.brakeTemp').css({width:brakeTemp*1.6});
	if (speed>1) {
		$('.brakeInfo').text("Brake Temperature: " + parseInt(brakeTemp) + "ºC");
	};

}